stages:
  - build
  - test

include:
  - template: Code-Quality.gitlab-ci.yml

image: docker:20.10.16

services:
  - docker:20.10.16-dind

.maven_cache: &maven_cache
  - key:
      files:
        - pom.xml
    paths:
      - .m2/repository/

variables:
  MAVEN_OPTS: "-Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository"
  NODE_VER: "16.20.0"
  JDK_VERSION: "17"

build:
  stage: build
  cache:
    - key:
        files:
          - frontend/package-lock.json
      paths:
        - frontend/node_modules/
    - *maven_cache
  before_script:
    - apk update
    - apk add --no-cache curl bash ca-certificates openssl ncurses coreutils python3 make gcc g++ libgcc linux-headers grep util-linux binutils findutils
    - apk add --no-cache openjdk$JDK_VERSION
    - touch ~/.profile && chmod +x ~/.profile
    - curl -o- https://raw.githubusercontent.com/nvm-sh/nvm/v0.39.3/install.sh | bash
    - echo 'source $HOME/.profile;' >> $HOME/.zshrc;
    - echo 'export NVM_NODEJS_ORG_MIRROR=https://unofficial-builds.nodejs.org/download/release;' >> $HOME/.profile;
    - echo 'nvm_get_arch() { nvm_echo "x64-musl"; }' >> $HOME/.profile;
    - NVM_DIR="$HOME/.nvm"
    - source $HOME/.nvm/nvm.sh
    - source $HOME/.profile
    - nvm install $NODE_VER
    - nvm use default
    - chmod +x ./mvnw
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - ./mvnw clean spring-boot:build-image -DincludeFrontend=true -Dspring-boot.build-image.imageName=app
    - |
        if [[ $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH ]]; then
            docker tag app $CI_REGISTRY_IMAGE:latest
            docker push $CI_REGISTRY_IMAGE:latest
        fi
    - |
        if [[ $CI_COMMIT_TAG ]]; then
            docker tag app $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
            docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
        else
            docker tag app $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME-b$CI_PIPELINE_IID
            docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME-b$CI_PIPELINE_IID
        fi

test:
  stage: test
  cache:
    - *maven_cache
  before_script:
    - apk update
    - apk add --no-cache openjdk$JDK_VERSION
    - chmod +x ./mvnw
  script:
    - ./mvnw clean test
